/****************************************************************************/
/*
                             ProxyCache.h


08-AUG-1998  MGD  initial
*/
/****************************************************************************/

#ifndef PROXYCACHE_H_LOADED
#define PROXYCACHE_H_LOADED 1

#include "proxystruct.h"

#define PROXY_CACHE_DEVICE  "HT_CACHE_ROOT:"
#define PROXY_CACHE_ROOT    PROXY_CACHE_DEVICE "["
#define PROXY_CACHE_SPEC    PROXY_CACHE_ROOT "000000...]*.HTC;*"

/* 256 top-level directories (original organization) */
#define PROXY_CACHE_DIR_ORG_FLAT256     256
/* 64 top-level directories each with 64 subdirectories */
#define PROXY_CACHE_DIR_ORG_64X64  6464

/* function prototypes */
ProxyCacheCloseAst_NetWrite (struct FAB*);
ProxyCacheCloseAst_ProxyEnd (struct FAB*);
int ProxyCacheDeltaSeconds (unsigned long*, unsigned long*);
ProxyCacheEnd (PROXY_TASK*);
ProxyCacheInit (BOOL);
ProxyCacheInitPurgeList ();
ProxyCacheLoadBegin (PROXY_TASK*);
ProxyCacheLoadConnect (struct FAB*);
ProxyCacheLoadWrite (PROXY_TASK*);
ProxyCacheLoadWriteAst (struct RAB*);
BOOL ProxyCachePurgeLimit (int, int);
int ProxyCacheReloadLastModified (unsigned long, unsigned long);
ProxyCacheInitReloadList ();
BOOL ProxyCacheReloadLimit (int, int);
ProxyCacheReadAcpInfo (struct FAB*);
ProxyCacheReadAccessAst (PROXY_TASK*);
ProxyCacheReadAcpInfoAst (PROXY_TASK*);
ProxyCacheReadNext (REQUEST_STRUCT*);
ProxyCacheReadNextAst (PROXY_TASK*);
ProxyCacheSetFileDateTime (PROXY_CACHE_FILE_QIO*,
                           unsigned long*, unsigned long*,
                           unsigned long*, unsigned long*);
ProxyCacheSetFileDateTime2 (PROXY_CACHE_FILE_QIO*);
ProxyCacheSetFileDateTimeAst (PROXY_CACHE_FILE_QIO*);

#endif /* PROXYCACHE_H_LOADED */

/****************************************************************************/
